package ch.unige.solidify.exception;

import java.time.LocalDateTime;

import org.springframework.http.HttpStatus;

import ch.unige.solidify.repository.SolidifyError;

public class SolidifyHttpErrorException extends SolidifyRuntimeException {
  HttpStatus httpStatus;
  String message;
  SolidifyError solidifyError;
  public SolidifyHttpErrorException(HttpStatus httpStatus, String message) {
    super(message);
    this.httpStatus = httpStatus;
    this.message = message;
    solidifyError = new SolidifyError();
    solidifyError.setError(httpStatus.toString());
    solidifyError.setMessage(message);
    solidifyError.setStatus(httpStatus);
    solidifyError.setTimeStamp(LocalDateTime.now().toString());
  }
  public SolidifyError getSolidifyError() {
    return this.solidifyError;
  }
}
