package ch.unige.solidify.test.controller.dao;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.OffsetDateTime;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

import org.springframework.data.jpa.domain.Specification;

import com.fasterxml.jackson.annotation.JsonIgnore;

import ch.unige.solidify.rest.ResourceCET;
import ch.unige.solidify.util.SearchCriteria;

@Entity
@Table(name = "MockUser")
public class MockUser extends ResourceCET<MockUser> {

  private int age;
  private LocalDate birthday;
  private Long carKilos;

  private Integer childNumber;
  @Id
  @Column(name = "id")
  private String entityId;
  private LocalDateTime marriageTime;
  private OffsetDateTime meetingTime;
  private String name;
  private BigDecimal salary;

  public MockUser() {
    super();
  }

  public MockUser(String name, int age, Integer childNumber, Long carKilos, BigDecimal salary,
          LocalDate birthday, LocalDateTime marriageTime, OffsetDateTime meetingTime) {
    this.name = name;
    this.age = age;
    this.childNumber = childNumber;
    this.carKilos = carKilos;
    this.salary = salary;
    this.birthday = birthday;
    this.marriageTime = marriageTime;
    this.meetingTime = meetingTime;
  }

  public MockUser(String id, String name, int age) {
    super();
    this.entityId = id;
    this.name = name;
    this.age = age;
  }

  public MockUser(String id, String name, int age, Integer childNumber, Long carKilos,
          BigDecimal salary, LocalDate birthday, LocalDateTime marriageTime,
          OffsetDateTime meetingTime) {
    this.entityId = id;
    this.name = name;
    this.age = age;
    this.childNumber = childNumber;
    this.carKilos = carKilos;
    this.salary = salary;
    this.birthday = birthday;
    this.marriageTime = marriageTime;
    this.meetingTime = meetingTime;
  }

  public int getAge() {
    return this.age;
  }

  public LocalDate getBirthday() {
    return this.birthday;
  }

  public Long getCarKilos() {
    return this.carKilos;
  }

  public Integer getChildNumber() {
    return this.childNumber;
  }

  @Override
  public String getEntityId() {
    return this.entityId;
  }

  public LocalDateTime getMarriageTime() {
    return this.marriageTime;
  }

  public OffsetDateTime getMeetingTime() {
    return this.meetingTime;
  }

  public String getName() {
    return this.name;
  }

  public BigDecimal getSalary() {
    return this.salary;
  }

  @Override
  @java.beans.Transient
  @JsonIgnore
  public Specification<MockUser> getSearchSpecification(SearchCriteria criteria) {
    return new MockUserSearchSpecification(criteria);
  }

  @Override
  public Specification<MockUser> getSpecification() {
    return new MockUserSpecification(this);
  }

  @Override
  public void init() {
  }

  @Override
  public String managedBy() {
    return null;
  }

  public void setAge(int age) {
    this.age = age;
  }

  public void setBirthday(LocalDate birthday) {
    this.birthday = birthday;
  }

  public void setCarKilos(Long carKilos) {
    this.carKilos = carKilos;
  }

  public void setChildNumber(Integer childNumber) {
    this.childNumber = childNumber;
  }

  public void setEntityId(String entityId) {
    this.entityId = entityId;
  }

  public void setMarriageTime(LocalDateTime marriageTime) {
    this.marriageTime = marriageTime;
  }

  public void setMeetingTime(OffsetDateTime meetingTime) {
    this.meetingTime = meetingTime;
  }

  public void setName(String name) {
    this.name = name;
  }

  public void setSalary(BigDecimal salary) {
    this.salary = salary;
  }

}
