package ch.unige.solidify.test.helper;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import ch.unige.solidify.SolidifyConstants;

public class FileUtils {
  private static final String FILE_SEPARATOR = SolidifyConstants.URL_SEP; // Should be always slash,
  // do not use
  // File.separator constant
  // because it's equals to
  // anti-slash on windows.

  public static void generateFile(String content, String outputFilePath) throws IOException {
    createDirectory(outputFilePath);
    try (FileWriter fileOutput = new FileWriter(outputFilePath)) {
      fileOutput.write(content);
    }
  }

  private static void createDirectory(String outputFilePath) {
    final File directory = new File(getDirectoryPath(outputFilePath));
    if (!directory.exists()) {
      directory.mkdirs();
    }
  }

  private static String getDirectoryPath(String outputFilePath) {
    if (outputFilePath.endsWith(FILE_SEPARATOR)) {
      return outputFilePath;
    }
    final int lastIndexOfSeparator = outputFilePath.lastIndexOf(FILE_SEPARATOR);
    return outputFilePath.substring(0, lastIndexOfSeparator);
  }
}
