package ch.unige.solidify.converter;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;

@Converter
public class FrenchBooleanConverter implements AttributeConverter<Boolean, String> {
  public static final String NON = "N";
  public static final String OUI = "O";

  @Override
  public String convertToDatabaseColumn(Boolean aBoolean) {
    if (aBoolean == null) {
      return null;
    }
    return (aBoolean) ? "O" : "N";
  }

  @Override
  public Boolean convertToEntityAttribute(String s) {
    if (s == null) {
      return null;
    }
    if (s.equalsIgnoreCase(OUI)) {
      return true;
    }
    if (s.equalsIgnoreCase(NON)) {
      return false;
    }

    throw new IllegalArgumentException(s);
  }
}
